(*
BUG1
The first confuses the range and domain types of the function in the application rule, and has the small counterexample: (hd 0).
Shallow, size 3  (hd 0)))

app rule the range of the function is matched to the argument
*)

func subst(exp,id,exp) = exp.
subst(error,_,_) = error.
subst(c(C) ,_,_) = c(C).
subst(var(X),X,N) = N.
subst(var(Y),X,N) = var(Y) :- X # Y.
subst(app(M1,M2),X,N) = app(subst(M1,X,N), subst(M2,X,N)).
subst(lam((y\M),T),X,N) = lam((y\subst(M,X,N)),T) :- y # (X,N).

pred substp(exp,id,exp,exp).
substp(M,X,N,M') :- subst(M,X,N) = M'.

pred neqty (ty,ty).
neqty(listTy,funTy(_)).
neqty(listTy,intTy).
neqty(funTy(_),listTy).
neqty(funTy(_),intTy).
neqty(intTy,listTy).
neqty(intTy,funTy(_)).
% (exists X7:ty. (exists X8:ty. (exists X9:ty. (exists X10:ty. X5 = (X7,X9), (Y6 = (X8,X10), (neqty(X7,X8) ; neqty(X9,X10))))))) => neqty(funTy(X5),funTy(Y6)).
neqty(funTy(X1,X2),funTy(Y1,Y2)) :- neqty(X1,Y1); neqty(X2,Y2).
% neqty(listTy,listTy) :- neqty(X3,Y4).

pred neqcnt(cnt,cnt).
neqcnt(toInt(_),nil).
neqcnt(toInt(_),tl).
neqcnt(toInt(_),hd).
neqcnt(toInt(_),cons).
neqcnt(nil,toInt(_)).
neqcnt(nil,tl).
neqcnt(nil,hd).
neqcnt(nil,cons).
neqcnt(tl,toInt(_)).
neqcnt(tl,nil).
neqcnt(tl,hd).
neqcnt(tl,cons).
neqcnt(hd,toInt(_)).
neqcnt(hd,nil).
neqcnt(hd,tl).
neqcnt(hd,cons).
neqcnt(cons,toInt(_)).
neqcnt(cons,nil).
neqcnt(cons,tl).
neqcnt(cons,hd).

pred neqexp(exp,exp).
neqexp(error,lam(_)).
neqexp(error,app(_)).
neqexp(error,var(_)).
neqexp(error,c(_)).
neqexp(lam(_),error).
(exists X13:id\exp. (exists X14:id\exp. (exists X15:ty. (exists X16:ty. X11 = (X13,X15), (Y12 = (X14,X16), ((new a17:id. neqexp(X13@a17,X14@a17)) ; neqty(X15,X16))))))) => neqexp(lam(X11),lam(Y12)).
neqexp(lam(_),app(_)).
neqexp(lam(_),var(_)).
neqexp(lam(_),c(_)).
neqexp(app(_),error).
neqexp(app(_),lam(_)).
% (exists X20:exp. (exists X21:exp. (exists X22:exp. (exists X23:exp. X18 = (X20,X22), (Y19 = (X21,X23), (neqexp(X20,X21) ; neqexp(X22,X23))))))) => neqexp(app(X18),app(Y19)).
neqexp(app(X1,X2),app(Y1,Y2)) :- neqexp(X1,Y1);neqexp(X2,Y2).

neqexp(app(_),var(_)).
neqexp(app(_),c(_)).
neqexp(var(_),error).
neqexp(var(_),lam(_)).
neqexp(var(_),app(_)).
% X24 # Y25 => neqexp(var(X24),var(Y25)).
neqexp(var(X24),var(Y25)) :- X24 # Y25.

neqexp(var(_),c(_)).
neqexp(c(_),error).
neqexp(c(_),lam(_)).
neqexp(c(_),app(_)).
neqexp(c(_),var(_)).
% neqcnt(X26,Y27) => neqexp(c(X26),c(Y27)).
neqexp(c(X26),c(Y27)) :- neqcnt(X26,Y27).

pred tcc (cnt,ty).
tcc(toInt(_N), intTy).
tcc(nil, listTy).
tcc(hd, funTy(listTy,intTy)).
tcc(tl, funTy(listTy,listTy)).
tcc(cons, funTy(intTy,funTy(listTy,listTy))).
% tcc(plus, funTy(intTy,funTy(intTy,intTy))).

pred nottcc (cnt,ty).
nottcc(toInt(_N),listTy).
nottcc(toInt(_N),funTy(_)).
nottcc(nil,intTy).
nottcc(nil,funTy(_)).
nottcc(hd,intTy).
nottcc(hd,listTy).
nottcc(hd,funTy(intTy,_)).
nottcc(hd,funTy(funTy(_),_)).
nottcc(hd,funTy(listTy,_)).
% nottcc(hd,funTy(listTy(funTy(_)),_)).
% nottcc(hd,funTy(listTy,listTy)).
% nottcc(hd,funTy(listTy,funTy(_))).
nottcc(tl,intTy).
nottcc(tl,listTy).
nottcc(tl,funTy(intTy,_)).
nottcc(tl,funTy(funTy(_),_)).
nottcc(tl,funTy(listTy,_)).
nottcc(tl,funTy(listTy,_)).
nottcc(tl,funTy(listTy,intTy)).
nottcc(tl,funTy(listTy,funTy(_))).
% nottcc(tl,funTy(listTy,listTy)).
% nottcc(tl,funTy(listTy,listTy(funTy(_)))).
nottcc(cons,intTy).
nottcc(cons,listTy).
nottcc(cons,funTy(listTy,_)).
nottcc(cons,funTy(funTy(_),_)).
nottcc(cons,funTy(intTy,intTy)).
nottcc(cons,funTy(intTy,listTy)).
nottcc(cons,funTy(intTy,funTy(intTy,_))).
nottcc(cons,funTy(intTy,funTy(funTy(_),_))).
nottcc(cons,funTy(intTy,funTy(listTy,intTy))).
nottcc(cons,funTy(intTy,funTy(listTy,funTy(_)))).

pred tc (ctx,exp,ty).
tc(_,error,T).
tc(_,c(C),T) :- tcf(C) = T.
tc([(Y,T)|G],var X,U) :- X = Y,T=U.
tc([_|G],var X,T) :- tc(G,var(X),T).
tc(G,app(M,N),U) :- exists T. tc(G,M,funTy(T,U)), tc(G,N,U). %%% here T := U
tc(G,lam(M,T),funTy(T_,U)) :- (new x:id.  tc([(x,T)|G],M@x,U), T=T_).

pred notmem ((id,ty),ctx).
notmem((_,_),[]).
notmem((X,T),[(Y,U)|G]) :- (X # Y; neqty(T,U)),notmem((X,T),G).

pred nottc(ctx,exp,ty).
nottc(_,c(C),T) :- nottcc(C,T).
% nottc([(Y,T)|G],var(X),U) :- neqty(T,U); X # Y.
nottc(G,var(X),T) :- notmem((X,T),G).
% nottc([_|G],var X,T) :- nottc(G,var X,T).
nottc(G,app(M,N),U) :- (forall T:ty. nottc(G,M,funTy(T,U))) ; nottc(G,N,U).
nottc(G,lam(M,T),funTy(T_,U)) :- (new x:id. nottc([(x,T)|G],M@x,U) ; neqty(T,T_)).
nottc(_,lam(_),intTy).
nottc(_,lam(_),listTy).

pred valid_ctx(ctx).
valid_ctx([]).
valid_ctx([(X,T)|G]) :- X # G, valid_ctx(G).


pred value(exp).
value(c(_)).
value(lam(_,_)).
value(app(c(cons),V)) :- value(V).
value(app(app(c(cons),V1),V2)) :- value(V1),value(V2).

pred step(exp,exp).
step(app(c(hd),app(app(c(cons),V),VS)),V) :- value(V),value(VS).
step(app(c(tl),app(app(c(cons),V),VS)),VS) :- value(V),value(VS).
step(app(lam(M,_),N),P) :- value(N), new a.  substp(M@a,a,N,P).
step(app(M1,M2),app(M1',M2')) :- step(M1,M1'), M2=M2'.
step(app(M1,M2),app(M1',M2')) :- value M1,  M1=M1', step(M2,M2').


pred exists_step(exp).
exists_step(app(lam(_),_)).
exists_step(app(c(hd),app(app(c(cons),V),VS))) :- value(V),value(VS).
exists_step(app(c(tl),app(app(c(cons),V),VS))) :- value(V),value(VS).


exists_step(app(M1,M2)) :- exists_step(M1).
exists_step(app(M1,M2)) :- value M1, exists_step(M2).

pred is_err(exp).
is_err(app(c(hd), c (nil))).
is_err(app(c(tl), c (nil))).
is_err(error).
is_err(app(E1,E2)) :- is_err(E1).
is_err(app(V1,E2)) :- value(V1),is_err(E2).

pred progress(exp).
progress(V) :- value(V).
progress(E) :- is_err(E).
progress(M) :- exists_step(M).


(*NE: 
pres

Total: 2.180536 s:
M = app(lam(x2774962\app(var(x2774962),error),funTy(T2925599,intTy)),c(toInt(_N3114621))) 
M' = app(c(toInt(_N3114621)),error) 
T = intTy 

progress fails

Total: 4.9258 s:
E = app(c(hd),c(toInt(_N1653371))) 
T = intTy 

hd(1)
*)

(* NF

Total: 0.302604 s:
M = app(lam(x\app(var(x),error),funTy(T,intTy)),c(toInt(_N))) 
M' = app(c(toInt(_N)),error) 
T = intTy 
a236018 # _N
a236018 # _N
x # T


same Total: 0.006527 s:
E = app(c(hd),c(toInt(_N1611))) 
T = intTy 

samebug
*)
